Index: code/branches/FlappyOrx_HS17/data/levels/FlappyOrx.oxw
===================================================================
--- code/branches/FlappyOrx_HS17/data/levels/FlappyOrx.oxw	(revision 11520)
+++ code/branches/FlappyOrx_HS17/data/levels/FlappyOrx.oxw	(revision 11521)
@@ -59,5 +59,5 @@
       angularDamping = 0
       scale = "<?lua print(10)?>"
-      collisiondamage = 0
+      collisiondamage = 100000
       enablecollisiondamage = true
     >
@@ -77,5 +77,5 @@
       angularDamping = 0
       scale = "<?lua print(10)?>"
-      collisiondamage = 0
+      collisiondamage = 100000
       enablecollisiondamage = true
     >
Index: code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrx.cc
===================================================================
--- code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrx.cc	(revision 11520)
+++ code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrx.cc	(revision 11521)
@@ -61,5 +61,5 @@
         this->center_ = nullptr;
         bEndGame = false;
-        lives = 3;
+        lives = 1;
         level = 1;
         point = 0;
Index: code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.cc
===================================================================
--- code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.cc	(revision 11520)
+++ code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.cc	(revision 11521)
@@ -51,8 +51,8 @@
         SUPER(FlappyOrxHUDinfo, XMLPort, xmlelement, mode);
 
-        XMLPortParam(FlappyOrxHUDinfo, "showlives",     setShowLives,     getShowLives,     xmlelement, mode).defaultValues(false);
-        XMLPortParam(FlappyOrxHUDinfo, "showPoints",     setShowPoints,     getShowPoints,     xmlelement, mode).defaultValues(false);
-        XMLPortParam(FlappyOrxHUDinfo, "showLevel",     setShowLevel,     getShowLevel,     xmlelement, mode).defaultValues(false);
-        XMLPortParam(FlappyOrxHUDinfo, "showMultiplier",     setShowMultiplier,     getShowMultiplier,     xmlelement, mode).defaultValues(false);
+        // XMLPortParam(FlappyOrxHUDinfo, "showlives",     setShowLives,     getShowLives,     xmlelement, mode).defaultValues(false);
+         XMLPortParam(FlappyOrxHUDinfo, "showPoints",     setShowPoints,     getShowPoints,     xmlelement, mode).defaultValues(false);
+        // XMLPortParam(FlappyOrxHUDinfo, "showLevel",     setShowLevel,     getShowLevel,     xmlelement, mode).defaultValues(false);
+        // XMLPortParam(FlappyOrxHUDinfo, "showMultiplier",     setShowMultiplier,     getShowMultiplier,     xmlelement, mode).defaultValues(false);
     }
 
@@ -63,35 +63,35 @@
         if (this->FlappyOrxGame)
         {
-            if (this->bShowLives_)
-            {
-                const std::string& lives = multi_cast<std::string>(this->FlappyOrxGame->getLives());
-                this->setCaption(lives);
-            }
-            else if(this->bShowLevel_)
-            {
-                const std::string& Level = multi_cast<std::string>(this->FlappyOrxGame->getLevel());
-                if (this->FlappyOrxGame->lives <= 0)
-                {
-                    setPosition(Vector2(0.1, 0.65));
-                    this->setCaption("Game ends in 30 seconds.\nPress (e)xit / (q)uit to go to the main menu.\nTo restart fly out of the screen!");
-                    setTextSize(0.05);
-                    this->FlappyOrxGame->bEndGame = true;
-                }
-                else if (this->FlappyOrxGame->bShowLevel)
-                {
-                    setTextSize(0.1);
-                    setPosition(Vector2(0.3, 0.55));
-                    std::stringstream sstm;
-                    sstm << "Level " << Level;
-                    this->setCaption(sstm.str()); // + level
-                }
-                else
-                {
-                    setTextSize(0.04);
-                    setPosition(Vector2(0.14, 0.055));
-                    this->setCaption(Level);
-                }
-            }
-            else if(this->bShowPoints_)
+            // if (this->bShowLives_)
+            // {
+            //     const std::string& lives = multi_cast<std::string>(this->FlappyOrxGame->getLives());
+            //     this->setCaption(lives);
+            // }
+            // else if(this->bShowLevel_)
+            // {
+            //     const std::string& Level = multi_cast<std::string>(this->FlappyOrxGame->getLevel());
+            //     if (this->FlappyOrxGame->lives <= 0)
+            //     {
+            //         setPosition(Vector2(0.1, 0.65));
+            //         this->setCaption("Game ends in 30 seconds.\nPress (e)xit / (q)uit to go to the main menu.\nTo restart fly out of the screen!");
+            //         setTextSize(0.05);
+            //         this->FlappyOrxGame->bEndGame = true;
+            //     }
+            //     else if (this->FlappyOrxGame->bShowLevel)
+            //     {
+            //         setTextSize(0.1);
+            //         setPosition(Vector2(0.3, 0.55));
+            //         std::stringstream sstm;
+            //         sstm << "Level " << Level;
+            //         this->setCaption(sstm.str()); // + level
+            //     }
+            //     else
+            //     {
+            //         setTextSize(0.04);
+            //         setPosition(Vector2(0.14, 0.055));
+            //         this->setCaption(Level);
+            //     }
+            // }
+            if(this->bShowPoints_)
             {
                 const std::string& points = multi_cast<std::string>(this->FlappyOrxGame->getPoints());
@@ -111,12 +111,12 @@
                 }
             }
-            else if(this->bShowMultiplier_)
-            {
-                int mult = this->FlappyOrxGame->getMultiplier();
-                const std::string& Multiplier = "X " + multi_cast<std::string>(mult);
-                this->setCaption(Multiplier);
-                this->setColour(ColourValue(1, 0, 0, clamp(float(mult * 0.1), 0.0f, 1.0f)));
-                this->setTextSize(clamp(float(mult * 0.1), 0.0f, 1.0f) * 0.01f + 0.04f);
-            }
+            // else if(this->bShowMultiplier_)
+            // {
+            //     int mult = this->FlappyOrxGame->getMultiplier();
+            //     const std::string& Multiplier = "X " + multi_cast<std::string>(mult);
+            //     this->setCaption(Multiplier);
+            //     this->setColour(ColourValue(1, 0, 0, clamp(float(mult * 0.1), 0.0f, 1.0f)));
+            //     this->setTextSize(clamp(float(mult * 0.1), 0.0f, 1.0f) * 0.01f + 0.04f);
+            // }
         }
     }
Index: code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.h
===================================================================
--- code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.h	(revision 11520)
+++ code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxHUDinfo.h	(revision 11521)
@@ -45,10 +45,10 @@
 
             inline void setShowLives(bool value)
-                { this->bShowLives_ = value; }
+                { this->bShowLives_ = false; }
             inline bool getShowLives() const
                 { return this->bShowLives_; }
 
             inline void setShowLevel(bool value)
-                { this->bShowLevel_ = value; }
+                { this->bShowLevel_ = false; }
             inline bool getShowLevel() const
                 { return this->bShowLevel_; }
@@ -60,5 +60,5 @@
 
             inline void setShowMultiplier(bool value)
-                { this->bShowMultiplier_ = value; }
+                { this->bShowMultiplier_ = false; }
             inline bool getShowMultiplier() const
                 { return this->bShowMultiplier_; }
Index: code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxShip.cc
===================================================================
--- code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxShip.cc	(revision 11520)
+++ code/branches/FlappyOrx_HS17/src/modules/flappyorx/FlappyOrxShip.cc	(revision 11521)
@@ -50,5 +50,5 @@
 
         this->UpwardThrust = 1;
-        this->speed = 1;orxout() << "constr speed set: " << 1 << endl;
+        this->speed = 1;
         this->gravity = 1;
         
@@ -68,5 +68,8 @@
         if (this->hasLocalController())
         {
-            
+            if(getHealth()<0){
+                 getGame()->costLife();
+                 getGame()->end();
+            }
             Vector3 pos = getPosition();
             velocity.y += gravity;